/*
*  defmsgdlgs.cpp 
*
*  Copyright (C) 2010 Richard Christman 
*
*  This file is part of QuickSilver Lite.
*
*  QuickSilver Lite is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by the 
*  Free Software Foundation; either version 3 of the License, or (at your 
*  option) any later version.
* 
*  This program is distributed in the hope that it will be useful, but 
*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
*  for more details.
* 
*  You should have received a copy of the GNU General Public License along 
*  with this program; if not, see <http://www.gnu.org/licenses>.
* 
*  Additional permission under GNU GPL version 3 section 7
* 
*  If you modify QuickSilver Lite, or any covered work, by linking or 
*  combining it with CodeGear VCL (or a modified version of that library), 
*  containing parts covered by the terms of CodeGear's license, the licensors 
*  of QuickSilver Lite grant you additional permission to convey the 
*  resulting work.
*
*/

//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "defmsgdlgs.h"
#include "utility.h"
#include "qsdbs.h"
#include "global.h"
//#include "setupdlgs.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
//TDefMessageDlg *DefMessageDlg;
const AnsiString newmsgmsg =
"    I need to create a default message. That's "
"where I'll store your email address. Please enter whatever you wish in the "
"space below. It can be your actual address or something bogus. Whatever you "
"use, it'll have to get past your SMTP server and that may require a valid domain.\n\n"
"    Whatever you use, don't worry. It won't be delivered with the message. "
"It'll be stripped away at the first remailer.";
//---------------------------------------------------------------------------

bool __fastcall CreateDefaultMessage(TForm *Owner)
{
   TStringList *msg = new TStringList();
   TDefMessageDlg *defmessagedlg = new TDefMessageDlg(Owner);
   defmessagedlg->ShowModal();
   bool ok = defmessagedlg->ModalResult == mrOk;
   if (ok)
   {
      msg->Add("From: " + defmessagedlg->Address->Text);
      msg->Add("Chain: *,*,*; copies=2;");
      msg->Add("To: ");
      msg->Add("Subject: ");
      msg->Add("");
      msg->Add("~~");
      DB->SaveDefMessage(msg);
   }
   delete defmessagedlg;
   delete msg;
   return ok;
}
//---------------------------------------------------------------------------

__fastcall TDefMessageDlg::TDefMessageDlg(TComponent* Owner)
        : TForm(Owner)
{
   PopupParent = (TForm*)Owner;
   TIniFile *ini = new TIniFile(AppIni());
   AssignFont(Font, ini->ReadString("settings", "dialogfont", OptsDefDialogFont));
   AssignFont(Address->Font, ini->ReadString("settings", "windowfont",
      OptsDefWindowFont));
   delete ini;

   Display->Clear();
   Display->Lines->Add(newmsgmsg);
   AssignFont(Font, OptsDefDialogFont);
}
//---------------------------------------------------------------------------

void __fastcall TDefMessageDlg::FormCloseQuery(TObject *Sender,
      bool &CanClose)
{
   if (ModalResult == mrOk)
   {
      AnsiString address = Address->Text;
      if (!address.Pos("@") || !address.Pos("."))
      {
         MsgBox(NULL,
            "I need an email address in the Address field. This is do or die. "
            "Without \nsomething, I'll have to close QS.",
            MT_INFO, MB_OK);
         ActiveControl = Address;
         CanClose = false;
         return;
      }
   }
}
//---------------------------------------------------------------------------
