/*
*  mixranddlgs.cpp 
*
*  Copyright (C) 2010 Richard Christman 
*
*  This file is part of QuickSilver Lite.
*
*  QuickSilver Lite is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by the 
*  Free Software Foundation; either version 3 of the License, or (at your 
*  option) any later version.
* 
*  This program is distributed in the hope that it will be useful, but 
*  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
*  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License 
*  for more details.
* 
*  You should have received a copy of the GNU General Public License along 
*  with this program; if not, see <http://www.gnu.org/licenses>.
* 
*  Additional permission under GNU GPL version 3 section 7
* 
*  If you modify QuickSilver Lite, or any covered work, by linking or 
*  combining it with CodeGear VCL (or a modified version of that library), 
*  containing parts covered by the terms of CodeGear's license, the licensors 
*  of QuickSilver Lite grant you additional permission to convey the 
*  resulting work.
*
*/

//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop
#include <stdio.h>


#include "mixranddlgs.h"
#include "utility.h"
#include "mixmaster.h"
#include "global.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
//TMixRandDlg *MixRandDlg;
//---------------------------------------------------------------------------

bool __fastcall GenMixmasterMixRandBin(TForm *Owner)
{
  TMixRandDlg *mixranddlg = new TMixRandDlg(Owner);
  mixranddlg->ShowModal();
  bool ok = mixranddlg->ModalResult == mrOk;
  delete mixranddlg;
  return ok;
}
//---------------------------------------------------------------------------

__fastcall TMixRandDlg::TMixRandDlg(TComponent* Owner)
        : TForm(Owner)
{
   PopupParent = (TForm*)Owner;
 //TIniFile *ini = new TIniFile(AppIni());
 //AssignFont(Font, ini->ReadString("settings", "dialogfont", OptsDefDialogFont));
 //delete ini;
   pencoords = new TStringList();
   PaintBox1->Align = alClient;
   PaintBox1->Canvas->Pen->Color = clWindowText;
   PaintBox1->Align = alClient;
   entropy_achieved = 0;
   pendown = false;
}
//---------------------------------------------------------------------------

__fastcall TMixRandDlg::~TMixRandDlg()
{
   delete pencoords;
}
//---------------------------------------------------------------------------

void __fastcall TMixRandDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult == mrCancel)
   {
      if (MessageBox(Handle,
         "I'll have to quit the QS program if you cancel now. Are you sure?  ",
         "Confirm", MB_ICONQUESTION | MB_YESNO) == IDNO)
      {
         CanClose = false;
         return;
      }
   }
}
//---------------------------------------------------------------------------

void __fastcall TMixRandDlg::PaintBox1MouseDown(TObject *Sender,
        TMouseButton Button, TShiftState Shift, int X, int Y)
{
   PaintBox1->Canvas->MoveTo(X,Y);
   pencoords->Add(AnsiString(X)+","+AnsiString(Y));
   pendown = true;
}
//---------------------------------------------------------------------------

void __fastcall TMixRandDlg::PaintPercent()
{
   OkBtn->Enabled = entropy_achieved >= 100;
   if (OkBtn->Enabled)
      MessageBeep(MB_OK);

   char pcnt[32]; sprintf(pcnt,"%3.0f",entropy_achieved);
   AnsiString percent = AnsiString(pcnt)+"%";

   TCanvas *canvas = PaintBox1->Canvas;
   int X = canvas->PenPos.x;
   int Y = canvas->PenPos.y;
   canvas->Font->Color = clWindowText;
   canvas->TextOut(Panel1->Width - (canvas->TextWidth(percent) + 8), 4, percent);
   canvas->MoveTo(X,Y);
}
//---------------------------------------------------------------------------

void __fastcall TMixRandDlg::PaintBox1MouseMove(TObject *Sender,
        TShiftState Shift, int X, int Y)
{
   if (pendown)
   {
      pencoords->Add(AnsiString(X)+","+AnsiString(Y));
      PaintBox1->Canvas->LineTo(X,Y);

	  entropy_achieved = rnd_mouse(WM_MOUSEMOVE, 0, MYMAKELONG(X, Y));//(double)entropy/(double)ENTROPYNEEDED*100;
      PaintPercent();
   }
}
//---------------------------------------------------------------------------

void __fastcall TMixRandDlg::PaintBox1MouseUp(TObject *Sender,
        TMouseButton Button, TShiftState Shift, int X, int Y)
{
   pendown = false;
}
//---------------------------------------------------------------------------

void __fastcall TMixRandDlg::PaintBox1Paint(TObject *Sender)
{
   for (int i = 0; i < pencoords->Count; i++)
   {
      AnsiString s = pencoords->Strings[i];
      if (i==0)
         PaintBox1->Canvas->MoveTo(
            GetTok(0, s, ',').ToInt(), GetTok(1, s, ',').ToInt()
         );
      else
         PaintBox1->Canvas->LineTo(
            GetTok(0, s, ',').ToInt(), GetTok(1, s, ',').ToInt()
         );
   }
   PaintPercent();
}
//---------------------------------------------------------------------------

