//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "uninstdlgs.h"
#include "global.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TUninstDlg *UninstDlg;
AnsiString msgtxt1 = // qsl in single directory -- no qsa
"I see all of your QSL program and data files are kept in the single directory "
"shown below. Click Ok and I'll open the directory in a File Explorer window. You "
"can delete the entire directory. If you wish to save your QSL data file, that would "
"be qs.db. Copy it to a safe location before deleting.";
AnsiString msgtxt2 = // qsl program/data in separate directories -- no qsa
"I see your QSL program files and data files are kept in the 2 separate directories "
"shown below. Click Ok and I'll open those directories in File Explorer windows. "
"You can delete the entire directories. If you wish to save your QSL data file, that "
"would be qs.db in the data directory. Copy it to a safe location before deleting.";
AnsiString msgtxt4 = // qsl/qsa in single directory
"I see all of your QSL/QSA program and data files are kept in the single directory "
"shown below. Click Ok and I'll open the directory in a File Explorer window. You "
"can delete the entire directory. If you wish to save your data files, those "
"would be qs.db and qsa.db. Copy those to a safe location before deleting.";
AnsiString msgtxt3 = // qsl/qsa program and data files in 3 separate directories
"I see your QSL and QSA program files and data files are kept in the 3 separate directories "
"shown below. Click Ok and I'll open those directories in File Explorer windows. "
"You can delete the entire directories. If you wish to save your data files, those "
"would be qs.db in the QSL data directory and qsa.db and in the QSA data "
"directory. Copy those to a safe location before deleting.";
AnsiString msgtxt5 = // qsl/qsa program and data files in 2 separate directories
"I see your QSL and QSA program files and data files are kept in the 2 separate directories "
"shown below. Click Ok and I'll open those directories in File Explorer windows. "
"You can delete the entire directories. If you wish to save your data files, those "
"would be qs.db for QSL and qsa.db for QSA. Copy those to a safe location before deleting.";
//---------------------------------------------------------------------------

bool __fastcall UninstallProgram(TForm *Owner)
{
   UninstDlg = new TUninstDlg(Owner);
   UninstDlg->ShowModal();
   bool ok = UninstDlg->ModalResult == mrOk;
   delete UninstDlg;
   return ok;
}
//---------------------------------------------------------------------------

__fastcall TUninstDlg::TUninstDlg(TComponent* Owner)
	: TForm(Owner)
{
   if (HasQSA())  // qsl & qsa share home dir
   {
	  Caption = "Uninstall QSLite & QSAam";
	  if (QSLHomeDir() == QSLDataDir()) // all program and data files same directory
	  {
		 Display->Lines->Text = msgtxt4+"\n\nQSL/QSA Home and Data Directory\n"+QSLHomeDir();
	  }
	  else // program and data in 3 files: qsl/qsa homedir, qsl datadir, qsa datadir
	  {
		 if (QSADataDir().LowerCase() == QSLDataDir().LowerCase())
		 {
			Display->Lines->Text = msgtxt5+"\n\nQSL/QSA Home Directory\n"+QSLHomeDir()+
			   "\n\nQSL/QSA Data Directory\n"+QSLDataDir();
		 }
		 else
		 {
			Display->Lines->Text = msgtxt3+"\n\nQSL/QSA Home Directory\n"+QSLHomeDir()+
			   "\n\nQSL Data Directory\n"+QSLDataDir()+
			   "\n\nQSA Data Directory\n"+QSADataDir();
		 }
	  }
   }
   else
   {
	  Caption = "Uninstall QSLite";
	  if (QSLHomeDir() == QSLDataDir())
	  {
		 Display->Lines->Text = msgtxt1+"\n\nQSL Home and Data Directory\n"+QSLHomeDir();
	  }
	  else
	  {
		 Display->Lines->Text = msgtxt2+"\n\nQSL Home Directory\n"+QSLHomeDir()+
			"\n\nQSL Data Directory\n"+QSLDataDir();
	  }
   }
}
//---------------------------------------------------------------------------

void __fastcall TUninstDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult == mrCancel)
	  return;

   if (HasQSA())
   {
	  if (QSLHomeDir() == QSLDataDir())
	  {
		 Snooze(300);
		 Hide(); Snooze(100); ((TForm*)Owner)->Hide();
		 Snooze(500);
		 ExploreFolder(QSLHomeDir(), "QSL/QSA Home Directory", nextX, nextY);
	  }
	  else
	  {
		 Hide(); Snooze(100); ((TForm*)Owner)->Hide();
		 Snooze(500);
		 if (QSADataDir() == QSLDataDir())
		 {
			ExploreFolder(QSLDataDir(), "QSL/QSA Data Directory", nextX, nextY);
			Snooze(500);
			ExploreFolder(QSLHomeDir(), "QSL/QSA Home Directory", nextX, nextY);
		 }
		 else
		 {
			ExploreFolder(QSADataDir(), "QSA Data Directory", nextX, nextY);
			Snooze(500);
			ExploreFolder(QSLDataDir(), "QSL Data Directory", nextX, nextY);
			Snooze(500);
			ExploreFolder(QSLHomeDir(), "QSL/QSA Home Directory", nextX, nextY);
		 }
	  }
   }
   else
   {
	  if (QSLHomeDir() == QSLDataDir())
	  {
		 Snooze(300);
		 Hide(); Snooze(100); ((TForm*)Owner)->Hide();
		 Snooze(500);
		 ExploreFolder(QSLDataDir(), "QSL Home and Data Directory", nextX, nextY);
	  }
	  else
	  {
		 Snooze(300);
		 Hide(); Snooze(100); ((TForm*)Owner)->Hide();
		 Snooze(500);
		 ExploreFolder(QSLHomeDir(), "QSL Home Directory", nextX, nextY);
		 Snooze(500);
		 ExploreFolder(QSLDataDir(), "QSL Data Directory", nextX, nextY);
	  }
   }
}
//---------------------------------------------------------------------------

AnsiString __fastcall TUninstDlg::QSLHomeDir()
{
   return AppDir().LowerCase();
}
//---------------------------------------------------------------------------

AnsiString __fastcall TUninstDlg::QSAHomeDir()
{
   if (HasQSA())
   {
	  return AppDir().LowerCase();
   }
   return "";
}
//---------------------------------------------------------------------------

AnsiString __fastcall TUninstDlg::QSLDataDir()
{
   return AppDataDir().LowerCase();
}
//---------------------------------------------------------------------------

AnsiString __fastcall TUninstDlg::QSADataDir()
{
   return QsaDataDir().LowerCase();
   /*if (HasQSA())
   {

	  if (FileExists(QSLDataDir()+"qsa.ini"))
	  {
		 return QSLDataDir();
	  }

	  AnsiString qsadatadir = QSLDataDir();
	  int x = qsadatadir.Length();
	  while (qsadatadir[x] != '\\' && x > 0)
	  {
		 qsadatadir = qsadatadir.SubString(1, x) + "qsa\\";
		 if (FileExists(qsadatadir+"qsa.ini"))
			return qsadatadir.LowerCase();
	  }
   return "";
   */
}
//---------------------------------------------------------------------------

bool __fastcall TUninstDlg::HasQSA()
{
   return FileExists(QSLHomeDir()+"qsa.exe");
}
//---------------------------------------------------------------------------

